import java.io.Serializable;
import java.awt.Color;
import java.awt.Rectangle;

public class Obstacle implements Serializable {

/****************************************************************/
/*	Declarations												*/
/****************************************************************/

	private int id;
	private Color obstacleColor = Color.black;
	private Rectangle boundingBox;

/****************************************************************/
/*	Constructors												*/
/****************************************************************/

	public Obstacle() {
		id = Application.generateId();
	}

/****************************************************************/
/*	Accessors													*/
/****************************************************************/

	public void setBoundingBox( Rectangle r ) {
		boundingBox = r;
	}

	public void setColor( Color c ) {
		obstacleColor = c;
	}

	public Color getColor() {
		return obstacleColor;
	}

	public Rectangle getBoundingBox() {
		return boundingBox;
	}

	public int getId() {
		return id;
	}

/****************************************************************/
/*	Methods														*/
/****************************************************************/

}