import java.io.Serializable;
import java.awt.Point;
import java.awt.Rectangle;

public class Spell implements Serializable {

/****************************************************************/
/*	Declarations												*/
/****************************************************************/

	private String name, level, school, components, castTime, range, effect, duration, save, resist;
	private Point location;
	private Rectangle boundingBox;
	private int id;

/****************************************************************/
/*	Constructors												*/
/****************************************************************/

	public Spell ( String n, String l,
				   String s, String c,
				   String ct, String r,
				   String e, String d,
				   String sa, String res ) {
		name = n;
		level = l;
		school = s;
		components = c;
		castTime = ct;
		range = r;
		effect = e;
		duration = d;
		save = sa;
		resist = res;
		id = Application.generateId();
	}

/****************************************************************/
/*	Accessors													*/
/****************************************************************/

	public void setBoundingBox( Rectangle r ) {
		boundingBox = r;
	}

	public void setLocation( Point p ) {
		location = p;
	}

	public String getSpellName() {
		return name;
	}

	public String getSpellLevel() {
		return level;
	}

	public String getSpellComponents() {
		return components;
	}

	public String getSpellSchool() {
		return school;
	}

	public String getSpellCastTime() {
		return castTime;
	}

	public String getSpellRange() {
		return range;
	}

	public String getSpellEffect() {
		return effect;
	}

	public String getSpellDuration() {
		return duration;
	}

	public String getSpellSave() {
		return save;
	}

	public String getSpellResist() {
		return resist;
	}

	public Point getLocation() {
		return location;
	}

	public Rectangle getBoundingBox() {
		return boundingBox;
	}

	public int getId() {
		return id;
	}
}