public class XPTable {

	private int[][] table = new int[ 20 ][ 20 ];

	public XPTable() {
		loadTable();
	}

	private void loadTable() {
		/* Load party level 1-3 CRs. */
		table[ 0 ][ 0 ] = 300;
		table[ 0 ][ 1 ] = 600;
		table[ 0 ][ 2 ] = 900;
		table[ 0 ][ 3 ] = 1350;
		table[ 0 ][ 4 ] = 1800;
		table[ 0 ][ 5 ] = 2700;
		table[ 0 ][ 6 ] = 3600;
		table[ 0 ][ 7 ] = 5400;
		table[ 0 ][ 8 ] = 7200;
		table[ 0 ][ 9 ] = 10800;
		table[ 0 ][ 10 ] = 0;
		table[ 0 ][ 11 ] = 0;
		table[ 0 ][ 12 ] = 0;
		table[ 0 ][ 13 ] = 0;
		table[ 0 ][ 14 ] = 0;
		table[ 0 ][ 15 ] = 0;
		table[ 0 ][ 16 ] = 0;
		table[ 0 ][ 17 ] = 0;
		table[ 0 ][ 18 ] = 0;
		table[ 0 ][ 19 ] = 0;

		/* Load party level 4 CRs. */
		table[ 1 ][ 0 ] = 300;
		table[ 1 ][ 1 ] = 600;
		table[ 1 ][ 2 ] = 800;
		table[ 1 ][ 3 ] = 1200;
		table[ 1 ][ 4 ] = 1600;
		table[ 1 ][ 5 ] = 2400;
		table[ 1 ][ 6 ] = 3200;
		table[ 1 ][ 7 ] = 4800;
		table[ 1 ][ 8 ] = 6400;
		table[ 1 ][ 9 ] = 9600;
		table[ 1 ][ 10 ] = 12800;
		table[ 1 ][ 11 ] = 0;
		table[ 1 ][ 12 ] = 0;
		table[ 1 ][ 13 ] = 0;
		table[ 1 ][ 14 ] = 0;
		table[ 1 ][ 15 ] = 0;
		table[ 1 ][ 16 ] = 0;
		table[ 1 ][ 17 ] = 0;
		table[ 1 ][ 18 ] = 0;
		table[ 1 ][ 19 ] = 0;

		/* Load party level 5 CRs. */
		table[ 2 ][ 0 ] = 300;
		table[ 2 ][ 1 ] = 500;
		table[ 2 ][ 2 ] = 750;
		table[ 2 ][ 3 ] = 1000;
		table[ 2 ][ 4 ] = 1500;
		table[ 2 ][ 5 ] = 2250;
		table[ 2 ][ 6 ] = 3000;
		table[ 2 ][ 7 ] = 4500;
		table[ 2 ][ 8 ] = 6000;
		table[ 2 ][ 9 ] = 9000;
		table[ 2 ][ 10 ] = 12000;
		table[ 2 ][ 11 ] = 18000;
		table[ 2 ][ 12 ] = 0;
		table[ 2 ][ 13 ] = 0;
		table[ 2 ][ 14 ] = 0;
		table[ 2 ][ 15 ] = 0;
		table[ 2 ][ 16 ] = 0;
		table[ 2 ][ 17 ] = 0;
		table[ 2 ][ 18 ] = 0;
		table[ 2 ][ 19 ] = 0;

		/* Load party level 6 CRs. */
		table[ 3 ][ 0 ] = 300;
		table[ 3 ][ 1 ] = 450;
		table[ 3 ][ 2 ] = 600;
		table[ 3 ][ 3 ] = 900;	
		table[ 3 ][ 4 ] = 1200;	
		table[ 3 ][ 5 ] = 1800;	
		table[ 3 ][ 6 ] = 2700;	
		table[ 3 ][ 7 ] = 3600;
		table[ 3 ][ 8 ] = 5400;	
		table[ 3 ][ 9 ] = 7200;	
		table[ 3 ][ 10 ] = 10800;	
		table[ 3 ][ 11 ] = 14400;
		table[ 3 ][ 12 ] = 21600;	
		table[ 3 ][ 13 ] = 0;	
		table[ 3 ][ 14 ] = 0;	
		table[ 3 ][ 15 ] = 0;	
		table[ 3 ][ 16 ] = 0;	
		table[ 3 ][ 17 ] = 0;	
		table[ 3 ][ 18 ] = 0;
		table[ 3 ][ 19 ] = 0;	

		/* Load party level 7 CRs. */
		table[ 4 ][ 0 ] = 263;
		table[ 4 ][ 1 ] = 394;
		table[ 4 ][ 2 ] = 525;
		table[ 4 ][ 3 ] = 700;
		table[ 4 ][ 4 ] = 1050;
		table[ 4 ][ 5 ] = 1400;
		table[ 4 ][ 6 ] = 2100;
		table[ 4 ][ 7 ] = 3150;
		table[ 4 ][ 8 ] = 4200;
		table[ 4 ][ 9 ] = 6300;
		table[ 4 ][ 10 ] = 8400;
		table[ 4 ][ 11 ] = 12600;
		table[ 4 ][ 12 ] = 16800;
		table[ 4 ][ 13 ] = 25200;
		table[ 4 ][ 14 ] = 0;
		table[ 4 ][ 15 ] = 0;
		table[ 4 ][ 16 ] = 0;
		table[ 4 ][ 17 ] = 0;
		table[ 4 ][ 18 ] = 0;
		table[ 4 ][ 19 ] = 0;
		
		/* Load party level 8 CRs. */
		table[ 5 ][ 0 ] = 200;
		table[ 5 ][ 1 ] = 300;
		table[ 5 ][ 2 ] = 450;
		table[ 5 ][ 3 ] = 600;
		table[ 5 ][ 4 ] = 800;
		table[ 5 ][ 5 ] = 1200;
		table[ 5 ][ 6 ] = 1600;
		table[ 5 ][ 7 ] = 2400;
		table[ 5 ][ 8 ] = 3600;
		table[ 5 ][ 9 ] = 4800;
		table[ 5 ][ 10 ] = 7200;
		table[ 5 ][ 11 ] = 9600;
		table[ 5 ][ 12 ] = 14400;
		table[ 5 ][ 13 ] = 19200;
		table[ 5 ][ 14 ] = 28800;
		table[ 5 ][ 15 ] = 0;
		table[ 5 ][ 16 ] = 0;
		table[ 5 ][ 17 ] = 0;
		table[ 5 ][ 18 ] = 0;
		table[ 5 ][ 19 ] = 0;

		/* Load party level 9 CRs. */
		table[ 6 ][ 0 ] = 0;
		table[ 6 ][ 1 ] = 225;
		table[ 6 ][ 2 ] = 338;
		table[ 6 ][ 3 ] = 506;
		table[ 6 ][ 4 ] = 675;
		table[ 6 ][ 5 ] = 900;
		table[ 6 ][ 6 ] = 1350;
		table[ 6 ][ 7 ] = 1800;
		table[ 6 ][ 8 ] = 2700;
		table[ 6 ][ 9 ] = 4050;
		table[ 6 ][ 10 ] = 5400;
		table[ 6 ][ 11 ] = 8100;
		table[ 6 ][ 12 ] = 10800;
		table[ 6 ][ 13 ] = 16200;
		table[ 6 ][ 14 ] = 21600;
		table[ 6 ][ 15 ] = 32400;
		table[ 6 ][ 16 ] = 0;
		table[ 6 ][ 17 ] = 0;
		table[ 6 ][ 18 ] = 0;
		table[ 6 ][ 19 ] = 0;

		/* Load party level 10 CRs. */
		table[ 7 ][ 0 ] = 0;
		table[ 7 ][ 1 ] = 0;
		table[ 7 ][ 2 ] = 250;
		table[ 7 ][ 3 ] = 375;
		table[ 7 ][ 4 ] = 563;
		table[ 7 ][ 5 ] = 750;
		table[ 7 ][ 6 ] = 1000;
		table[ 7 ][ 7 ] = 1500;
		table[ 7 ][ 8 ] = 2000;
		table[ 7 ][ 9 ] = 3000;
		table[ 7 ][ 10 ] = 4500;
		table[ 7 ][ 11 ] = 6000;
		table[ 7 ][ 12 ] = 9000;
		table[ 7 ][ 13 ] = 12000;
		table[ 7 ][ 14 ] = 18000;
		table[ 7 ][ 15 ] = 24000;
		table[ 7 ][ 16 ] = 36000;
		table[ 7 ][ 17 ] = 0;
		table[ 7 ][ 18 ] = 0;
		table[ 7 ][ 19 ] = 0;

		/* Load party level 11 CRs. */
		table[ 8 ][ 0 ] = 0;
		table[ 8 ][ 1 ] = 0;
		table[ 8 ][ 2 ] = 0;
		table[ 8 ][ 3 ] = 275;
		table[ 8 ][ 4 ] = 413;
		table[ 8 ][ 5 ] = 619;
		table[ 8 ][ 6 ] = 825;
		table[ 8 ][ 7 ] = 1100;
		table[ 8 ][ 8 ] = 1650;
		table[ 8 ][ 9 ] = 2200;
		table[ 8 ][ 10 ] = 3300;
		table[ 8 ][ 11 ] = 4950;
		table[ 8 ][ 12 ] = 6600;
		table[ 8 ][ 13 ] = 9900;
		table[ 8 ][ 14 ] = 13200;
		table[ 8 ][ 15 ] = 19800;
		table[ 8 ][ 16 ] = 26400;
		table[ 8 ][ 17 ] = 39600;
		table[ 8 ][ 18 ] = 0; 
		table[ 8 ][ 19 ] = 0;

		/* Load party level 12 CRs. */
		table[ 9 ][ 0 ] = 0;
		table[ 9 ][ 1 ] = 0;
		table[ 9 ][ 2 ] = 0;
		table[ 9 ][ 3 ] = 0;
		table[ 9 ][ 4 ] = 300;
		table[ 9 ][ 5 ] = 450;
		table[ 9 ][ 6 ] = 675;
		table[ 9 ][ 7 ] = 900;
		table[ 9 ][ 8 ] = 1200;
		table[ 9 ][ 9 ] = 1800;
		table[ 9 ][ 10 ] = 2400;
		table[ 9 ][ 11 ] = 3600;
		table[ 9 ][ 12 ] = 5400;
		table[ 9 ][ 13 ] = 7200;
		table[ 9 ][ 14 ] = 10800;
		table[ 9 ][ 15 ] = 14400;
		table[ 9 ][ 16 ] = 21600;
		table[ 9 ][ 17 ] = 28800;
		table[ 9 ][ 18 ] = 43200;
		table[ 9 ][ 19 ] = 0;

		/* Load party level 13 CRs. */
		table[ 10 ][ 0 ] = 0;
		table[ 10 ][ 1 ] = 0;
		table[ 10 ][ 2 ] = 0;
		table[ 10 ][ 3 ] = 0;
		table[ 10 ][ 4 ] = 0;
		table[ 10 ][ 5 ] = 325;
		table[ 10 ][ 6 ] = 488;
		table[ 10 ][ 7 ] = 731;
		table[ 10 ][ 8 ] = 975;
		table[ 10 ][ 9 ] = 1300;
		table[ 10 ][ 10 ] = 1950;
		table[ 10 ][ 11 ] = 2600;
		table[ 10 ][ 12 ] = 3900;
		table[ 10 ][ 13 ] = 5850;
		table[ 10 ][ 14 ] = 7800;
		table[ 10 ][ 15 ] = 11700;
		table[ 10 ][ 16 ] = 15600;
		table[ 10 ][ 17 ] = 23400;
		table[ 10 ][ 18 ] = 31200;
		table[ 10 ][ 19 ] = 46800;
	
		/* Load party level 14 CRs. */
		table[ 11 ][ 0 ] = 0;
		table[ 11 ][ 1 ] = 0;
		table[ 11 ][ 2 ] = 0;
		table[ 11 ][ 3 ] = 0;
		table[ 11 ][ 4 ] = 0;
		table[ 11 ][ 5 ] = 0;
		table[ 11 ][ 6 ] = 350;
		table[ 11 ][ 7 ] = 525;
		table[ 11 ][ 8 ] = 788;
		table[ 11 ][ 9 ] = 1050;
		table[ 11 ][ 10 ] = 1400;
		table[ 11 ][ 11 ] = 2100;
		table[ 11 ][ 12 ] = 2800;
		table[ 11 ][ 13 ] = 4200;
		table[ 11 ][ 14 ] = 6300;
		table[ 11 ][ 15 ] = 8400;
		table[ 11 ][ 16 ] = 12600;
		table[ 11 ][ 17 ] = 16800;
		table[ 11 ][ 18 ] = 25200;
		table[ 11 ][ 19 ] = 33600;

		/* Load party level 15 CRs. */
		table[ 12 ][ 0 ] = 0;
		table[ 12 ][ 1 ] = 0;
		table[ 12 ][ 2 ] = 0;
		table[ 12 ][ 3 ] = 0;
		table[ 12 ][ 4 ] = 0;
		table[ 12 ][ 5 ] = 0;
		table[ 12 ][ 6 ] = 0;
		table[ 12 ][ 7 ] = 375;
		table[ 12 ][ 8 ] = 563;
		table[ 12 ][ 9 ] = 844;
		table[ 12 ][ 10 ] = 1125;
		table[ 12 ][ 11 ] = 1500;
		table[ 12 ][ 12 ] = 2250;
		table[ 12 ][ 13 ] = 3000;
		table[ 12 ][ 14 ] = 4500;
		table[ 12 ][ 15 ] = 6750;
		table[ 12 ][ 16 ] = 9000;
		table[ 12 ][ 17 ] = 13500;
		table[ 12 ][ 18 ] = 18000;
		table[ 12 ][ 19 ] = 27000;

		/* Load party level 16 CRs. */
		table[ 13 ][ 0 ] = 0;
		table[ 13 ][ 1 ] = 0;
		table[ 13 ][ 2 ] = 0;
		table[ 13 ][ 3 ] = 0;
		table[ 13 ][ 4 ] = 0;
		table[ 13 ][ 5 ] = 0;
		table[ 13 ][ 6 ] = 0;
		table[ 13 ][ 7 ] = 0;
		table[ 13 ][ 8 ] = 400;
		table[ 13 ][ 9 ] = 600;
		table[ 13 ][ 10 ] = 900;
		table[ 13 ][ 11 ] = 1200;
		table[ 13 ][ 12 ] = 1600;
		table[ 13 ][ 13 ] = 2400;
		table[ 13 ][ 14 ] = 3200;
		table[ 13 ][ 15 ] = 4800;
		table[ 13 ][ 16 ] = 7200;
		table[ 13 ][ 17 ] = 9600;
		table[ 13 ][ 18 ] = 14400;
		table[ 13 ][ 19 ] = 19200;
 	
		/* Load party level 17 CRs. */
		table[ 14 ][ 0 ] = 0;
		table[ 14 ][ 1 ] = 0;
		table[ 14 ][ 2 ] = 0;
		table[ 14 ][ 3 ] = 0;
		table[ 14 ][ 4 ] = 0;
		table[ 14 ][ 5 ] = 0;
		table[ 14 ][ 6 ] = 0;
		table[ 14 ][ 7 ] = 0;
		table[ 14 ][ 8 ] = 0;
		table[ 14 ][ 9 ] = 425;
		table[ 14 ][ 10 ] = 638;
		table[ 14 ][ 11 ] = 956;
		table[ 14 ][ 12 ] = 1275;
		table[ 14 ][ 13 ] = 1700;
		table[ 14 ][ 14 ] = 2550;
		table[ 14 ][ 15 ] = 3400;
		table[ 14 ][ 16 ] = 5100;
		table[ 14 ][ 17 ] = 7650;
		table[ 14 ][ 18 ] = 10200;
		table[ 14 ][ 19 ] = 15300;

 		/* Load party level 18 CRs. */
		table[ 15 ][ 0 ] = 0;
		table[ 15 ][ 1 ] = 0;
		table[ 15 ][ 2 ] = 0;
		table[ 15 ][ 3 ] = 0;
		table[ 15 ][ 4 ] = 0;
		table[ 15 ][ 5 ] = 0;
		table[ 15 ][ 6 ] = 0;
		table[ 15 ][ 7 ] = 0;
		table[ 15 ][ 8 ] = 0;
		table[ 15 ][ 9 ] = 0;
		table[ 15 ][ 10 ] = 450; 
		table[ 15 ][ 11 ] = 675;
		table[ 15 ][ 12 ] = 1013;
		table[ 15 ][ 13 ] = 1350;
		table[ 15 ][ 14 ] = 1800;
		table[ 15 ][ 15 ] = 2700;
		table[ 15 ][ 16 ] = 3600;
		table[ 15 ][ 17 ] = 5400;
		table[ 15 ][ 18 ] = 8100;
		table[ 15 ][ 19 ] = 10800;

		/* Load party level 19 CRs. */
		table[ 16 ][ 0 ] = 0;
		table[ 16 ][ 1 ] = 0;
		table[ 16 ][ 2 ] = 0;
		table[ 16 ][ 3 ] = 0;
		table[ 16 ][ 4 ] = 0;
		table[ 16 ][ 5 ] = 0;
		table[ 16 ][ 6 ] = 0;
		table[ 16 ][ 7 ] = 0;
		table[ 16 ][ 8 ] = 0;
		table[ 16 ][ 9 ] = 0;
		table[ 16 ][ 10 ] = 0; 
		table[ 16 ][ 11 ] = 475;
		table[ 16 ][ 12 ] = 713;
		table[ 16 ][ 13 ] = 1069;
		table[ 16 ][ 14 ] = 1425;
		table[ 16 ][ 15 ] = 1900;
		table[ 16 ][ 16 ] = 2850;
		table[ 16 ][ 17 ] = 3800;
		table[ 16 ][ 18 ] = 5700;
		table[ 16 ][ 19 ] = 8550;

		/* Load party level 20 CRs. */
		table[ 17 ][ 0 ] = 0;
		table[ 17 ][ 1 ] = 0;
		table[ 17 ][ 2 ] = 0;
		table[ 17 ][ 3 ] = 0;
		table[ 17 ][ 4 ] = 0;
		table[ 17 ][ 5 ] = 0;
		table[ 17 ][ 6 ] = 0;
		table[ 17 ][ 7 ] = 0;
		table[ 17 ][ 8 ] = 0;
		table[ 17 ][ 9 ] = 0;
		table[ 17 ][ 10 ] = 0;
		table[ 17 ][ 11 ] = 0;
		table[ 17 ][ 12 ] = 500;
		table[ 17 ][ 13 ] = 750;
		table[ 17 ][ 14 ] = 1000;
		table[ 17 ][ 15 ] = 1500;
		table[ 17 ][ 16 ] = 2000;
		table[ 17 ][ 17 ] = 3000;
		table[ 17 ][ 18 ] = 4000;
		table[ 17 ][ 19 ] = 6000;
	}

	/* Converts a party level into a table row number. */
	private int getTableRow( int i ) {
		if ( i <=3 ) {
			return 0;
		}
		else {
			return i - 3;
		}
	}

	/* Converts a challenge rating into a table column number. */
	private int getTableCol( int i ) {
		return i - 1;
	}

	/* Given a party level rating and a challenge rating,
 	   returns the correct XP value for that encounter. */
	public int calculateTotalXP ( int partyLevel, int challengeRating ) {
		int row = getTableRow( partyLevel );
		int col = getTableCol( challengeRating );
		return table[ row ][ col ];
	}

	/* Given the party level rating, challenge rating, and number of players,
	   returns the XP earned by each player. */
	public int calculatePlayerXP( int plr, int cr, int np ) {
		int totalXP = calculateTotalXP( plr, cr );
		return totalXP/np;
	}

	/* Test harness. */
	public static void main( String[] args ) {
		XPTable xpt = new XPTable();
		System.out.println( "Party level 1, challenge rating 1" );
		System.out.println( "Expected output of 300" );
		System.out.print( "Calculated output of " );
		System.out.println( xpt.calculateTotalXP( 1, 1 ) );
		System.out.println();
		System.out.println( "Party level 5, challenge rating 7" );
		System.out.println( "Expected output of 3000" );
		System.out.print( "Calculated output of " );
		System.out.println( xpt.calculateTotalXP( 5, 7 ) );
	}
}